local libName, libVersion = "LibOmniMessage", 100
local lib = {}

lib.redColor     = "|cffaaaa"
lib.greenColor   = "|caaffaa"
lib.blueColor    = "|caaaaff"

lib.yellowColor  = "|cffffaa"
lib.cyanColor    = "|caaffff"
lib.purpleColor  = "|cffaaff"
lib.greyColor    = "|cdddddd"

lib.clearToWhite = "|r|cffffff"
lib.clearColor   = "|r"

function lib:Title(addonName)
  return lib.blueColor..addonName..": "..lib.clearToWhite
end

function lib:Format(textMessage, formatTable, indicator, replaceWith)
  if type(formatTable) == "table" and type(textMessage) == "string" then
    for indicator, replaceWith in pairs(formatTable) do
      textMessage = textMessage:gsub("(<)(<)LOM(-)"..indicator.."(>)(>)", replaceWith)
    end
  end

  return textMessage
end

function lib:Alert(alertText, sound, csa)
  sound = sound or SOUNDS.DISPLAY_ANNOUNCEMENT
  csa   = csa   or CENTER_SCREEN_ANNOUNCE_TYPE_LORE_BOOK_LEARNED_SKILL_EXPERIENCE

  local messageParams = CENTER_SCREEN_ANNOUNCE:CreateMessageParams(CSA_CATEGORY_LARGE_TEXT, sound)

  messageParams:SetText(alertText)
  messageParams:SetCSAType(csa)

  CENTER_SCREEN_ANNOUNCE:AddMessageWithParams(messageParams)
end

function lib:Send(textMessage, formatTable)
  if not textMessage or type(textMessage) ~= "string" then return end

  textMessage = formatTable and lib:Format(textMessage, formatTable) or textMessage
  textMessage = textMessage.."|r"

  local windowIndex, tabIndex

  for windowIndex = 1, #CHAT_SYSTEM.containers do
    for tabIndex  = 1, #CHAT_SYSTEM.containers[windowIndex].windows do
      CHAT_SYSTEM.containers[windowIndex].windows[tabIndex].buffer:AddMessage(textMessage)
    end
  end
end

CHAT_SYSTEM.AddMessage = function(self, value)
  lib:Send(lib.yellowColor..tostring(value)..lib.clearColor)
end

LibOmniMessage = lib